import es
import popuplib
import playerlib
import services
import random
from es import server_var

info = es.AddonInfo()
info.name = 'Model Disguiser'
info.version = '1.2'
info.basename = 'model_disguiser'
info.author = 'Killergp123'

def load():
    global tempadmin, tempmodel, tempid, command, name, idname, adminname, tempskin, tempchoice, tempname, money, ch_x, ch_y, ch_z
    global feather1, feather2, chicken, tempchicken, ccount, coord, mddict, randnum, randmod, tempvar, templine
    if not es.exists('saycommand', '!disguise'):
        es.regsaycmd("!disguise","model_disguiser/showpopup")
    mddict = {}
    auth = services.use("auth")
    auth.registerCapability("model_menu", auth.ADMIN)
    es.setinfo('md_ver', '1.2')
    es.makepublic('md_ver')
    es.setinfo('cash', '0')
    es.setinfo('mdadmin', '0')
    es.setinfo('adminannounce', '0')
    es.setinfo('chickenfeather', '0')
    es.setinfo('chickensound', '0')
    es.setinfo('feathernum', '0')
    es.setinfo('modelname1', '0')
    es.setinfo('model1', '0')
    es.setinfo('modelname2', '0')
    es.setinfo('model2', '0')
    es.setinfo('modelname3', '0')
    es.setinfo('model3', '0')
    es.setinfo('modelname4', '0')
    es.setinfo('model4', '0')
    es.setinfo('modelname5', '0')
    es.setinfo('model5', '0')
    es.setinfo('modelname6', '0')
    es.setinfo('model6', '0')
    es.setinfo('modelname7', '0')
    es.setinfo('model7', '0')
    es.setinfo('modelname8', '0')
    es.setinfo('model8', '0')
    es.setinfo('modelname9', '0')
    es.setinfo('model9', '0')
    es.setinfo('modelname10', '0')
    es.setinfo('model10', '0')
    es.setinfo('botrand', '0')
    es.setinfo('botrandpercent', '0')
    es.stringtable('downloadables', 'models/lduke/chicken/chicken3.dx80.vtx')
    es.stringtable('downloadables', 'models/lduke/chicken/chicken3.dx90.vtx')
    es.stringtable('downloadables', 'models/lduke/chicken/chicken3.mdl')
    es.stringtable('downloadables', 'models/lduke/chicken/chicken3.phy')
    es.stringtable('downloadables', 'models/lduke/chicken/chicken3.sw.vtx')
    es.stringtable('downloadables', 'models/lduke/chicken/chicken3.vvd')
    es.stringtable('downloadables', 'models/lduke/chicken/feather2.dx80.vtx')
    es.stringtable('downloadables', 'models/lduke/chicken/feather2.dx90.vtx')
    es.stringtable('downloadables', 'models/lduke/chicken/feather2.mdl')
    es.stringtable('downloadables', 'models/lduke/chicken/feather2.phy')
    es.stringtable('downloadables', 'models/lduke/chicken/feather2.sw.vtx')
    es.stringtable('downloadables', 'models/lduke/chicken/feather2.vvd')
    es.stringtable('downloadables', 'models/lduke/chicken/feather.dx80.vtx')
    es.stringtable('downloadables', 'models/lduke/chicken/feather.dx90.vtx')
    es.stringtable('downloadables', 'models/lduke/chicken/feather.mdl')
    es.stringtable('downloadables', 'models/lduke/chicken/feather.phy')
    es.stringtable('downloadables', 'models/lduke/chicken/feather.sw.vtx')
    es.stringtable('downloadables', 'models/lduke/chicken/feather.vvd')
    es.stringtable('downloadables', 'materials/models/lduke/chicken/chicken2.vmt')
    es.stringtable('downloadables', 'materials/models/lduke/chicken/feather.vmt')
    es.stringtable('downloadables', 'materials/models/lduke/chicken/chicken2.vtf')
    es.stringtable('downloadables', 'materials/models/lduke/chicken/feather.vtf')
    es.stringtable('downloadables', 'sound/lduke/chicken/chicken.wav')
    es.msg('#multi', '#green[Model Disguiser]#lightgreenLoaded!')
    feather1 = "models/lduke/chicken/feather.mdl"
    feather2 = "models/lduke/chicken/feather2.mdl"
    es.mexec('../addons/eventscripts/model_disguiser/mdconfig.cfg')
    es.ServerCommand('es_doblock model_disguiser/load2')
    
def unload():
    global mddict
    del mddict
    es.msg('#multi', '#green[Model Disguiser]#lightgreenUn-Loaded!')
    es.unregsaycmd('!disguise')
    if popuplib.exists('mdadminmenu'):
        popuplib.delete('mdadminmenu')
    if popuplib.exists('modelmenu'):
        popuplib.delete('modelmenu')
    if popuplib.exists('modelmenu2'):
        popuplib.delete('modelmenu2')
        
def showpopup():
    global partialtext, tempid
    partialtext = 0
    partialtext = es.getargs()
    tempid = es.getcmduserid()
    popuplib.send("modelmenu", tempid)
        
def player_spawn(event_var):
    global mddict, userid, randnum, randmod, partialtext
    userid = int(event_var['userid'])
    mddict[userid] = {}
    mddict[userid]['name'] = event_var['es_username']
    mddict[userid]['chicken'] = '0'
    if event_var['es_steamid'] == "BOT":
        if server_var['botrand'] == "1":
            randnum = random.randint(1, 100)
            if randnum <= int(server_var['botrandpercent']):
                randmod = random.randint(1, 10)
                partialtext = "random"
                name(userid, randmod, partialtext)
    
def player_hurt(event_var):
    global chicken, coord, ch_x, ch_y, ch_z, mddict, userid
    userid = int(event_var['userid'])
    if event_var['attacker'] != event_var['userid']:
        chicken = mddict[userid]['chicken']
        if chicken == 1:
            if server_var['chickenfeather'] == 1:
                ccount = 0
                coord = es.getplayerlocation(event_var['userid'])
                ch_x = coord[0]
                ch_y = coord[1]
                ch_z = coord[2]
                ch_z = ch_z + 15
                feathernum = int(server_var['feathernum'])
                while ccount < feathernum:
                    ccount = ccount + 1
                    es.server.cmd('est_effect 12 #a 0 %s %d %d %d 0 0 0 0 0 100 0 0 0' % (feather1, ch_x, ch_y, ch_z))
                    es.server.cmd('est_effect 12 #a 0 %s %d %d %d 0 0 0 0 0 100 0 0 0' % (feather2, ch_x, ch_y, ch_z))
            if server_var['chickensound'] == 1:
                es.emitsound('player', event_var['userid'], 'lduke/chicken/chicken.wav', 1.0, 0.5)
                
def player_death(event_var):
    global mddict, userid
    userid = int(event_var['userid'])
    mddict[userid]['chicken'] = '0'
    
def player_disconnect(event_var):
    global mddict, userid
    userid = int(event_var['userid'])
    mddict[userid].clear()

def es_map_start(event_var):
    es.stringtable('downloadables', 'models/lduke/chicken/chicken3.dx80.vtx')
    es.stringtable('downloadables', 'models/lduke/chicken/chicken3.dx90.vtx')
    es.stringtable('downloadables', 'models/lduke/chicken/chicken3.mdl')
    es.stringtable('downloadables', 'models/lduke/chicken/chicken3.phy')
    es.stringtable('downloadables', 'models/lduke/chicken/chicken3.sw.vtx')
    es.stringtable('downloadables', 'models/lduke/chicken/chicken3.vvd')
    es.stringtable('downloadables', 'models/lduke/chicken/feather2.dx80.vtx')
    es.stringtable('downloadables', 'models/lduke/chicken/feather2.dx90.vtx')
    es.stringtable('downloadables', 'models/lduke/chicken/feather2.mdl')
    es.stringtable('downloadables', 'models/lduke/chicken/feather2.phy')
    es.stringtable('downloadables', 'models/lduke/chicken/feather2.sw.vtx')
    es.stringtable('downloadables', 'models/lduke/chicken/feather2.vvd')
    es.stringtable('downloadables', 'models/lduke/chicken/feather.dx80.vtx')
    es.stringtable('downloadables', 'models/lduke/chicken/feather.dx90.vtx')
    es.stringtable('downloadables', 'models/lduke/chicken/feather.mdl')
    es.stringtable('downloadables', 'models/lduke/chicken/feather.phy')
    es.stringtable('downloadables', 'models/lduke/chicken/feather.sw.vtx')
    es.stringtable('downloadables', 'models/lduke/chicken/feather.vvd')
    es.stringtable('downloadables', 'materials/models/lduke/chicken/chicken2.vmt')
    es.stringtable('downloadables', 'materials/models/lduke/chicken/feather.vmt')
    es.stringtable('downloadables', 'materials/models/lduke/chicken/chicken2.vtf')
    es.stringtable('downloadables', 'materials/models/lduke/chicken/feather.vtf')
    es.stringtable('downloadables', 'sound/lduke/chicken/chicken.wav')
    
def mdadmin():
    global tempid
    if popuplib.exists('mdadminmenu'):
        popuplib.delete('mdadminmenu')
    mdadminmenu = popuplib.create("mdadminmenu")
    mdadminmenu.editlang = "en"
    
    mdadminmenu.addline("Model Disguiser Admin Menu")
    mdadminmenu.addline("By: Killergp123")
    if server_var['chickenfeather'] == "1":
        tempvar = "off"
    else:
        tempvar = "on"
    templine = "->1. Turn " + tempvar + " Chicken Feathers"
    mdadminmenu.addline(templine)
    if server_var['chickensound'] == "1":
        tempvar = "off"
    else:
        tempvar = "on"
    templine = "->2. Turn " + tempvar + " Chicken Sounds"
    mdadminmenu.addline(templine)
    if server_var['botrand'] == "1":
        tempvar = "off"
    else:
        tempvar = "on"
    templine = "->3. Turn " + tempvar + " Random bot models"
    mdadminmenu.addline(templine)
    if server_var['adminannounce'] == "1":
        tempvar = "off"
    else:
        tempvar = "on"
    templine = "->4. Turn " + tempvar + " announcing of admin actions"
    mdadminmenu.addline(templine)
    mdadminmenu.menuselect = admin
    tempid = es.getcmduserid()
    popuplib.send("mdadminmenu", tempid)
    
def admin(userid, choice, popupid):
    global mddict, adminname
    adminname = mddict[userid]['name']
    if choice == 1:
        if server_var['chickenfeather'] == "1":
            es.setinfo('chickenfeather', '0')
            if server_var['adminannounce'] == "1":
                es.msg('#multi', '#green[Model Disguiser]#lightgreenAdmin %s has turned off chicken feathers' % adminname)
            else:
                es.tell(userid, '#multi', '#green[Model Disguiser]#lightgreenYou have turned off chicken feathers')
        else:
            es.setinfo('chickenfeather', '1')
            if server_var['adminannounce'] == "1":
                es.msg('#multi', '#green[Model Disguiser]#lightgreenAdmin %s has turned on chicken feathers' % adminname)
            else:
                es.tell(userid, '#multi', '#green[Model Disguiser]#lightgreenYou have turned on chicken feathers')
    if choice == 2:
        if server_var['chickensound'] == "1":
            es.setinfo('chickensound', '0')
            if server_var['adminannounce'] == "1":
                es.msg('#multi', '#green[Model Disguiser]#lightgreenAdmin %s has turned off chicken sounds' % adminname)
            else:
                es.tell(userid, '#multi', '#green[Model Disguiser]#lightgreenYou have turned off chicken sounds')
        else:
            es.setinfo('chickensound', '1')
            if server_var['adminannounce'] == "1":
                es.msg('#multi', '#green[Model Disguiser]#lightgreenAdmin %s has turned on chicken sounds' % adminname)
            else:
                es.tell(userid, '#multi', '#green[Model Disguiser]#lightgreenYou have turned on chicken sounds')
    if choice == 3:
        if server_var['botrand'] == "1":
            es.setinfo('botrand', '0')
            if server_var['adminannounce'] == "1":
                es.msg('#multi', '#green[Model Disguiser]#lightgreenAdmin %s has turned off random bot models' % adminname)
            else:
                es.tell(userid, '#multi', '#green[Model Disguiser]#lightgreenYou have turned off random bot models')
        else:
            es.setinfo('botrand', '1')
            if server_var['adminannounce'] == "1":
                es.msg('#multi', '#green[Model Disguiser]#lightgreenAdmin %s has turned on random bot models' % adminname)
            else:
                es.tell(userid, '#multi', '#green[Model Disguiser]#lightgreenYou have turned on random bot models')
    if choice == 4:
        if server_var['adminannounce'] == "1":
            es.setinfo('adminannounce', '0')
            if server_var['adminannounce'] == "1":
                es.msg('#multi', '#green[Model Disguiser]#lightgreenAdmin %s has turned off announcing of admin actions' % adminname)
            else:
                es.tell(userid, '#multi', '#green[Model Disguiser]#lightgreenYou have turned off announcing of admin actions')
        else:
            es.setinfo('adminannounce', '1')
            if server_var['adminannounce'] == "1":
                es.msg('#multi', '#green[Model Disguiser]#lightgreenAdmin %s has turned on announcing of admin actions' % adminname)
            else:
                es.tell(userid, '#multi', '#green[Model Disguiser]#lightgreenYou have turned on announcing of admin actions')
def load2():
    if server_var['mdadmin'] == "1":
        if not es.exists('saycommand', '!mdadmin'):
            es.regsaycmd("!mdadmin","model_disguiser/mdadmin")
    else:
        if es.exists('saycommand', '!mdadmin'):
            es.unregsaycmd('!mdadmin')
    modelmenu = popuplib.create("modelmenu")
    modelmenu2 = popuplib.create("modelmenu2")
    modelmenu.editlang = "en"
    modelmenu2.editlang = "en"
    
    modelmenu.addline("Model Disguiser Shop v1.2")
    modelmenu.addline("By: Killergp123")
    tempmodel = "Any Disguise Costs$" + server_var['cash']
    modelmenu.addline(tempmodel)
    tempmodel = "->1. " + server_var['modelname1']
    modelmenu.addline(tempmodel)
    tempmodel = "->2. " + server_var['modelname2']
    modelmenu.addline(tempmodel)
    tempmodel = "->3. " + server_var['modelname3']
    modelmenu.addline(tempmodel)
    tempmodel = "->4. " + server_var['modelname4']
    modelmenu.addline(tempmodel)
    tempmodel = "->5. " + server_var['modelname5']
    modelmenu.addline(tempmodel)
    tempmodel = "->6. " + server_var['modelname6']
    modelmenu.addline(tempmodel)
    tempmodel = "->7. " + server_var['modelname7']
    modelmenu.addline(tempmodel)
    tempmodel = "->8. " + server_var['modelname8']
    modelmenu.addline(tempmodel)
    modelmenu.addline('->9. Next Page')
    modelmenu.addline('->0. Exit')
    
    modelmenu2.addline("Model Disguiser Shop v1.2")
    modelmenu2.addline("By: Killergp123")
    tempmodel = "Any Disguise Costs$" + server_var['cash']
    modelmenu2.addline(tempmodel)
    tempmodel = "->1. " + server_var['modelname9']
    modelmenu2.addline(tempmodel)
    tempmodel = "->2. " + server_var['modelname10']
    modelmenu2.addline(tempmodel)
    modelmenu2.addline('->8. Previous Page')
    #modelmenu2.addline('->9. Next Page')
    modelmenu2.addline('->0. Exit')

    modelmenu.submenu(9, modelmenu2)
    modelmenu2.submenu(8, modelmenu)
    #modelmenu2.submenu(9, modelmenu3)
    
    modelmenu.menuselect = model
    modelmenu2.menuselect = model2

def model(userid, choice, popupid):
    global tempchoice, adminid
    adminid = int(userid)
    if choice ==1:
        tempchoice = 1
        name(adminid, tempchoice, partialtext)
    if choice == 2:
        tempchoice = 2
        name(adminid, tempchoice, partialtext)
    if choice == 3:
        tempchoice = 3
        name(adminid, tempchoice, partialtext)
    if choice == 4:
        tempchoice = 4
        name(adminid, tempchoice, partialtext)
    if choice == 5:
        tempchoice = 5
        name(adminid, tempchoice, partialtext)
    if choice == 6:
        tempchoice = 6
        name(adminid, tempchoice, partialtext)
    if choice == 7:
        tempchoice = 7
        name(adminid, tempchoice, partialtext)
    if choice == 8:
        tempchoice = 8
        name(adminid, tempchoice, partialtext)
        
def model2(userid, choice, popupid):
    global tempchoice, adminid
    adminid = int(userid)
    #mdplayer = playerlib.getPlayer(userid)
    if choice == 1:
        tempchoice = 9
        name(adminid, tempchoice, partialtext)
    if choice == 2:
        tempchoice = 10
        name(adminid, tempchoice, partialtext)
        
def name(adminid, tempchoice, partialtext):
    global mddict, adminname, username
    adminname = mddict[adminid]['name']
    tempchicken = 0
    if tempchoice == 1:
        tempmname = server_var['modelname1']
        tempindex = str(server_var['model1'])
    if tempchoice == 2:
        tempmname = server_var['modelname2']
        tempindex = str(server_var['model2'])
    if tempchoice == 3:
        tempmname = server_var['modelname3']
        tempindex = str(server_var['model3'])
    if tempchoice == 4:
        tempmname = server_var['modelname4']
        tempindex = str(server_var['model4'])
    if tempchoice == 5:
        tempmname = server_var['modelname5']
        tempindex = str(server_var['model5'])
    if tempchoice == 6:
        tempmname = server_var['modelname6']
        tempindex = str(server_var['model6'])
    if tempchoice == 7:
        tempmname = server_var['modelname7']
        tempindex = str(server_var['model7'])
    if tempchoice == 8:
        tempmname = server_var['modelname8']
        tempindex = str(server_var['model8'])
    if tempchoice == 9:
        tempmname = server_var['modelname9']
        tempindex = str(server_var['model9'])
    if tempchoice == 10:
        tempmname = server_var['modelname10']
        tempindex = str(server_var['model10'])
        tempchicken = 1
    if str(partialtext) == 'random':
        username = mddict[adminid]['name']
        mdplayer = playerlib.getPlayer(adminid)
        mdplayer.set('model', tempindex)
        mddict[adminid]['chicken'] = tempchicken
        es.msg('#multi', '#green[Model Disguiser]#lightgreenBot %s has randomly become a %s' % (username, tempmname))
    elif str(partialtext) == 'None':
        mdplayer = playerlib.getPlayer(adminid)
        money = mdplayer.get('cash')
        if int(server_var['cash']) <= money:
            money = money - int(server_var['cash'])
            mdplayer.set('cash', money)
            mdplayer.set('model', tempindex)
            mddict[adminid]['chicken'] = tempchicken
            #es est_SetPlayerColor server_var(_popup_userid) 255 255 255 255
            es.tell(adminid, '#multi', '#green[Model Disguiser]#default You are now disguised as a %s' % tempmname)
        else:
            es.tell(adminid, '#multi', '#green[Model Disguiser]#lightgreenYou do not have enough cash.')
    else:
        auth = services.use("auth")
        if auth.isUseridAuthorized(adminid, "model_menu"):
            if str(partialtext) == "#all":
                if server_var['adminannounce'] == "1":
                    es.msg('#multi', '#green[Model Disguiser]#lightgreenAdmin %s has disguised everyone as a %s' % (adminname, tempmname))
                else:
                    es.tell(adminid, '#multi', '#green[Model Disguiser]#lightgreenYou have disguised everyone as a %s' % tempmname)
                mdplayers = playerlib.getPlayerList('#alive')
                for player in mdplayers:
                    tempid = int(player)
                    mdplayer = playerlib.getPlayer(tempid)
                    mdplayer.set('model', tempindex)
                    mddict[tempid]['chicken'] = tempchicken
            elif str(partialtext) == "#bot":
                if server_var['adminannounce'] == "1":
                    es.msg('#multi', '#green[Model Disguiser]#lightgreenAdmin %s has disguised all bots as a %s' % (adminname, tempmname))
                else:
                    es.tell(adminid, '#multi', '#green[Model Disguiser]#lightgreenYou have disguised all bots as a %s' % tempmname)
                mdplayers = playerlib.getPlayerList('#bot,#alive')
                for player in mdplayers:
                    tempid = int(player)
                    mdplayer = playerlib.getPlayer(tempid)
                    mdplayer.set('model', tempindex)
                    mddict[tempid]['chicken'] = tempchicken
            elif str(partialtext) == "#human":
                if server_var['adminannounce'] == "1":
                    es.msg('#multi', '#green[Model Disguiser]#lightgreenAdmin %s has disguised all humans as a %s' % (adminname, tempmname))
                else:
                    es.tell(adminid, '#multi', '#green[Model Disguiser]#lightgreenYou have disguised all humans as a %s' % tempmname)
                mdplayers = playerlib.getPlayerList('#human,#alive')
                for player in mdplayers:
                    tempid = int(player)
                    mdplayer = playerlib.getPlayer(tempid)
                    mdplayer.set('model', tempindex)
                    mddict[tempid]['chicken'] = tempchicken
            elif str(partialtext) == "#ct":
                if server_var['adminannounce'] == "1":
                    es.msg('#multi', '#green[Model Disguiser]#lightgreenAdmin %s has disguised all Counter-Terrorists as a %s' % (adminname, tempmname))
                else:
                    es.tell(adminid, '#multi', '#green[Model Disguiser]#lightgreenYou have disguised all Counter-Terrorists as a %s' % tempmname)
                mdplayers = playerlib.getPlayerList('#ct,#alive')
                for player in mdplayers:
                    tempid = int(player)
                    mdplayer = playerlib.getPlayer(tempid)
                    mdplayer.set('model', tempindex)
                    mddict[tempid]['chicken'] = tempchicken
            elif str(partialtext) == "#t":
                if server_var['adminannounce'] == "1":
                    es.msg('#multi', '#green[Model Disguiser]#lightgreenAdmin %s has disguised all Terrorists as a %s' % (adminname, tempmname))
                else:
                    es.tell(adminid, '#multi', '#green[Model Disguiser]#lightgreenYou have disguised all Terrorists as a %s' % tempmname)
                mdplayers = playerlib.getPlayerList('#t,#alive')
                for player in mdplayers:
                    tempid = int(player)
                    mdplayer = playerlib.getPlayer(tempid)
                    mdplayer.set('model', tempindex)
                    mddict[tempid]['chicken'] = tempchicken
            else:
                for userid in mddict:
                    if str(partialtext) in str(mddict[userid]['name']):
                        tempid = int(userid)
                        username = mddict[userid]['name']
                        es.tell(adminid, '#multi', '#green[Model Disguiser]#lightgreenYou have disguised %s as a %s' % (username, tempmname))
                        es.tell(tempid, '#multi', '#green[Model Disguiser]#lightgreenYou have been disguised as a %s by %s' % (tempmname, adminname))
                        mdplayer = playerlib.getPlayer(tempid)
                        mdplayer.set('model', tempindex)
                        mddict[tempid]['chicken'] = tempchicken
        else:
            es.tell(adminid, '#multi', '#green[Model Disguiser]#lightgreen You are not an admin')